/*=========================================================================
    BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "win/win.h"
#include "win/other.h"
#include "define.h"
#include "common.h"

#include "bieamp-con.h"

#ifndef TAGEDIT_ONLY   //--------  start TAGEDIT_ONLY ----
#include "player.h"
#endif  //---------  end TAGEDIT_ONLY --------------------


#define VERSION "1.1"



//ޥɥ饤ѥ᡼طե饰ν
struct control_flag con_flag;


int main(int argc, char *argv[])
{
  InputMP3 *pInputMP3 = (InputMP3 *)new InputMP3();
  
  int i;
  char path[256];
  char *temp;

  //С
  ShowVersion(VERSION);

  //ѥ᡼̵äإפɽƽλ
  if(argc <= 1){
    ShowHelpCommandLine();
    return 0;
  }

  //-------------------------
  if(pInputMP3 == NULL){
    delete pInputMP3;
    return 1;
  }

  //-------------------------
  //ޥɥ饤󥹥åν
  con_flag.convert_char = CC_NONE;
  con_flag.no_prompt = false;
  con_flag.edit_id3tag = false;
  con_flag.no_message = false;
  con_flag.help = false;
  for(i=2;i<=argc;i++){
    CheckControlSwitch(argv[i-1],&con_flag);
  }
  
  if(con_flag.help){
    ShowHelpCommandLine();
    return 0;
  }

  if(con_flag.edit_id3tag){
    //id3TagΥޥɥ饤󤫤Խ
    CommandLineTagEdit(argc,argv,pInputMP3);
  }else{
#ifndef TAGEDIT_ONLY
    //̾α
    StartPlayer(argc,argv,pInputMP3);
#else
    printf("ޥɥ饤󤫤ΥԽѤ˥ѥ뤵Ƥޤ\n");
#endif
  }

  delete pInputMP3;

  return 0;
}




//---------------------------------------------------------
//ޥɥ饤Υå
// -s2e SJIS -> EUC Ѵ
//      ץ졼䡼SJISTAGEUCѴɽ
//                    ԽEUCϤSJIS¸                
//      ԽSJISϤEUCѴ¸
// -e2s EUC -> SJIS Ѵ
//      s2eε
// -np ץ졼䡼ǥץץȤɽʤ
// -h  --help إ
//
// -ei --editid3tag Խ⡼ɤǵư
// -nm --no_message Խ˽ϤԤʤʤ
//
// -tr --trackname CTE_TRACK_NAME
// -ar --artistname CTE_ARTIST_NAME
// -al --albumname CTE_ALBUM_NAME
// -ye --year CTE_YEAR
// -co --comment CTE_COMMENT
// -ge --genre CTE_GENRE
void CheckControlSwitch(char *param,struct control_flag *cf)
{
  if(*param == '-'){
    param++;
    if(strcmp(param,"s2e") == 0){
      cf->convert_char = CC_SJIS2EUC;
      return;
    }
    if(strcmp(param,"e2s") == 0){
      cf->convert_char = CC_EUC2SJIS;
      return;
    }
    if(strcmp(param,"np") == 0){
      cf->no_prompt = true;
      return;
    }
    if(strcmp(param,"h") == 0 || strcmp(param,"-help") == 0){
      cf->help = true;
      return;
    }
    if(strcmp(param,"-editid3tag") == 0 || strcmp(param,"ei") == 0){
      cf->edit_id3tag = true;
      return;
    }
    if(strcmp(param,"nm") == 0 || strcmp(param,"-no_message") == 0){
      cf->no_message = true;
    }
  }
}
//----------------------------------------------------------
//ޥɥ饤ѥإ
void ShowHelpCommandLine(void)
{
  //ؤ
  printf("Ȥ: \n");
  printf("   player mode  : bieamp [options] FILES...\n");
  printf("   tagEdit mode : bieamp -[ei|editid3tag] [options]\n\n");
  printf(" Player Mode\n");
  printf("   options:\n");
  printf("     -s2e id3TagʸɤS-JISEUCѴ\n");
  printf("          Խ򤷤ϵդS-JISؤɤ\n");
  printf("     -np  ޥϤɽʤ\n");
  printf(" files:\n");
  printf("   *.mp3, *.m3u\n");
  printf("\n");
  printf(" ID3TagEditor Mode\n");
  printf("   options:\n");
  printf("     -ei FILE , --editid3tag FILE  ޥɥ饤󤫤ID3TagԽޤ\n");
  printf("     -nm , --no_message            Խ˷̤γǧϤԤʤʤ\n");
  printf("     -s2e    SJISϤEUCѴƥ¸롣\n");
  printf("     -tr \"̾\" , --trackname \"̾\"  ̾ꤷޤ\n");
  printf("     -ar \"ƥ̾\" , --artistname \"ƥ̾\" \n");
  printf("     -al \"Х̾\" , --albumname \"Х̾\" \n");
  printf("     -ye ǯ , --year ǯ \n");
  printf("     -co \"\" , --comment \"\" \n");
  printf("     -ge ֹ , --genre ֹ(0156)\n");
  printf("\n");
  printf("­:\n");
  printf(" ư\"h\"or\"?\"ǡإɽ\n");
  printf(" M3UեκƵƽФOK\n");
}
//----------------------------------------------------------
//Сɽ
void ShowVersion(char *ver)
{
  printf("Bieamp ");
  printf("Version %s\n",ver);
}



