/*=========================================================================
    BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
//#include <sys/types.h>
#include <sys/wait.h>

#include "win/win.h"
#include "win/other.h"
#include "define.h"
#include "common.h"

#include "player.h"
#include "prompt.h"


//ޥɥ饤ѥ᡼طե饰ν
// biemap-con.cpp
extern struct control_flag con_flag;

//ȥåȥ빽¤
struct track_control next_track;



//---------------------------------------------------------
//  ץ䡼ط
//---------------------------------------------------------

//---------------------------------------------------------
// ץ졼䡼
BOOL StartPlayer(int argc,char *argv[],InputMP3 *pInputMP3)
{
  int i;
  int pid;
  InputItem *pItem;
  OutputAudio *pOutput = (OutputAudio *)new OutputAudio();
  TInputItemDB *pItemDB = (TInputItemDB *)new TInputItemDB();

  if(pOutput == NULL || pItemDB == NULL){
    delete pOutput;
    delete pItemDB;
    return false;
  }

  //ȥåȥ빽¤Τν
  next_track.finish = false;
  next_track.change = false;
  next_track.state = 0;
  next_track.position = 0;


  //--------------------------
  //եꥹȤκ
  for(i=2;i<=argc;i++){
    if(*argv[i-1] == '-'){
      continue;
    }
    AddPlayList(pItemDB,argv[i-1]);
  }
  pItemDB->SetTrack(1);
  
  //--------------------------
  //ǥɥ饹νΰ
  pInputMP3->setCallback(&InputProc,0);
  pInputMP3->setOutput(pOutput);
  
  //----------------------------
  //ץκ
  pid = fork();
  switch(pid){
  case -1:
    fprintf(stderr,"main : ץǤޤǤ\n");
    break;
  case 0:
    //------------------------------------------
    //ҥץ
    //    fprintf(stderr,"Start Child Process(%d)\n",getpid());
    while(1){
      //    for(i=0;i<pItemDB->GetItemCount();i++){
      pItem = pItemDB->GetCurrentItem();
      if(pItem != NULL){
	PlaySound(pInputMP3,pItem->path);
      }
      //롼׽λ?
      if(next_track.finish){
	break;
      }
      //˱դȥå
      if(next_track.change == false){
	pItemDB->SetNext();
      }else{
	if(next_track.state == 0){
	  //ȥåл
	  pItemDB->SetTrack(next_track.position);
	}else{
	  //ȥåл
	  pItemDB->SetTrack(pItemDB->GetCurrentTrack() + next_track.position);
	}
	next_track.change = false;
      }
      //ǽʤ˰ư鼡ǽλ!
      if(pItemDB->GetCurrentTrack() == pItemDB->GetItemCount()){
	next_track.finish = true;
      }
    }
    
    //ҥץλ
    //    fprintf(stderr,"fin child proccess\n");
    exit(0);
    
    break;
  default:
    //--------------------------------------------
    //ץ
    //    fprintf(stderr,"Start Process(%d)\n",getpid());
    if(con_flag.no_prompt == false){
      CommandPrompt(pInputMP3,pItemDB);
    }
    wait(NULL);
    break;
  }
  
  //---------------------------
  //ץ쥤ꥹȤκ
  pItemDB->ClearItem();
  
  //  fprintf(stderr,"End Child and Parent Process\n");

  delete pItemDB;
  delete pOutput;
  
  return true;
}

//---------------------------------------------------------
//ץ쥤ꥹȤ
//m3uξϺƵƤӽФ
BOOL AddPlayList(TInputItemDB *pItemDB,char *path)
{
  FILE *fp;
  char line[MAX_PATH],*temp;
  InputItem *pItem;

  //m3uŸ
  if(CheckExt(path) == EXT_M3U){
    if((fp = fopen(path,"r")) == 0){
      fprintf(stderr,"AddPlayList : Not Open M3U File!\n");
      return 0;
    }
    while(fgets(line,MAX_PATH-1,fp) != NULL){
      if(line[0] == '#'){
	continue;
      }
      temp = strstr(line,"\n");
      *temp = '\0';
      AddPlayList(pItemDB,line);
    }
    fclose(fp);

    return true;
  }

  //ǥեɲ
  pItem = pItemDB->AddItem();
  if(pItem != NULL){
    strncpy(pItem->path,path,MAX_PATH);
  }

  return true;
}

//---------------------------------------------------------
// 
int PlaySound(InputMP3 *pInputMP3,char *path)
{
  BOOL re;
  InputInfo iInfo;

  re = pInputMP3->open(path,&iInfo);
  if(re == true){
    //    ShowTagLite(&iInfo,0);
    //    pInputMP3->setVolume(20,20);
    if(pInputMP3->play() == false){
      fprintf(stderr,"PlaySound : Not Play\n");
    }
    pInputMP3->close();      
  }else{
    fprintf(stderr,"PlaySound : Not open MP3 file!\n");
  }

  return 0;
}
//---------------------------------------------------------
//ǥɥ롼פθƽФ
int InputProc(int id, int param, int userData)
{
  if(id ==  MSG_SEND_TO_OTHER_PROCESS){
    switch(param){
    case COM_EXIT:
      next_track.finish = true;
      break;
    case COM_PREV:
      next_track.change = true;
      next_track.state = 1;
      next_track.position = -1;
      next_track.finish = false;
      break;
    case COM_SET_TRACK:
      next_track.change = true;
      next_track.state = 0;
      next_track.position = userData;
      next_track.finish = false;
      break;
    default:
      break;
    }
  }
}

