/*=========================================================================
    BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>

#include "../define.h"
#include "win.h"
#include "other.h"

//---------------------------------------------------------------------------
//#pragma package(smart_init)

//void SetBmpHeader(BitMapStruct *Bmp,int width,int height);
int CeilFloor(double interval);


char *Genre[157]={"Blues","Classic Rock","Country","Dance","Disco",
		  "Funk","Grunge","Hip-Hop","Jazz","Metal",
		  "New Age","Oldies","Other","Pop","R&B",
		  "Rap","Reggae","Rock","Techno","Industrial",
		  "Alternative","Ska","Death Metal","Pranks","Soundtrack",
		  "Euro-tecno","Ambient","Trip-Hop","Vocal","Juzz+Funk",
		  "Fusion","Trance","Classical","Instrumental","Acid",
		  "House","Game","Sound Cip","Gospel","Noise",
		  "AlternRock","Bass","Soul","Punk","Space",
		  "Meditative","Instrumental Pop","Instrumental Rock","Ethnic","Gothic",
		  "Darkwave","Techno-Industrial","Electronic","Pop-Folk","Eurodance",
		  "Dream","Southern Rock","Comedy","Cult","Gangsta",
		  "Top 40","Christian Rap","Pop/Funk","Jungle","Native American",
		  "Cabaret","New Wave","Psychadelic","Rave","Showtunes",
		  "Trailer","Lo-Fi","Tribal","Acid Punk","Acid Jazz",
		  "Polka","Retro","Musical","Rock & Roll","Hard Rock",
		  "Folk","Folk/Rock","National Folk","Swing","Fast-Fusion",
		  "Bedob","Latin","Revival","Celtic","Bluegrass",
		  "Avantagarde","Gothic Rock","Progressive Rock","Psychadelic Rock","Symphonic Rock",
		  "Slow Rock","Big band","Chorus","Easy Listening","Acoustic",
		  "Humour","SpeechChanson","Chanson","Opera","Chamber Music",
		  "Sonata","Symphony","Booty Bass","Primus","Porn Groove",
		  "Satire","Slow Jam","Club","Tango","Samba",
		  "Folklore","Ballad","Power Ballad","Rhytmic Soul","Freeyle",
		  "Duet","Punk Rock","Drum Solo","Acapella","Euro-House",
		  "Dance Hall","Goa","Drum & Bass","Club-House","Hardcore",
		  "Terror","Indie","BritPop","Negerpunk","Polsk Punk",
		  "Beat","Christian Gangsta Rap","Heavy Metal","Black Metal","Crossover",
		  "Contemporary Christian","Christian Rock","Merengue","Salsa","Thrash Metal",
		  "Anime","JPop","Synthpop"};



//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//¾
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//ѥե̾
//---------------------------------------------------------------------------
void GetFileName(char* dest,char* path)
{
  int pos,len;
  char *temp;

  pos = strlen(path);
  temp = path;
  temp += pos-1;
  while(*temp != '/'){
    pos--;
    if(pos < 0){
      break;
    }
    temp--;
  }
  temp++;
  strcpy(dest,temp);

  return;
}


/*--------------------------------------
//---------------------------------------------------------------------------
//ѥĥҤФ
//
//---------------------------------------------------------------------------
AnsiString GetFileExt(AnsiString path)
{
    int pos = path.Pos(".");
    path.Delete(1,pos);
    return path.LowerCase();
}

--------------------------------------*/

/*----------------------------------------
//---------------------------------------------------------------------------
//ѥǥ쥯ȥ
//---------------------------------------------------------------------------
AnsiString GetFileDir(AnsiString path)
{
    int len = path.Length();

    while( path.SubString(len,1) != "\\"){
        path.Delete(len,1);
        len--;
        if(len <= 0){
            return "c:\\";
        }
    }
    return path;
}
-----------------------------------------*/


//---------------------------------------------------------------------------
//ѥեˤĤƤ֤
//---------------------------------------------------------------------------
int GetFileNumber(char *path)
{
  char file[MAX_PATH];
  char *temp;
  int pos;
  int len;
  
  GetFileName(file,path);

  //ԥꥪɤΰ֤򤵤
  pos = strlen(file);
  temp = file;
  temp += pos - 1;
  while(*temp != '.'){
    pos--;
    if(pos <= 0){
      break;
    }
    temp--;
  }
  //ԥꥪɤΰ֤ǽλ
  *temp = '\0';

  //κǽ򤵤
  temp--;
  while(*temp >= '0' && *temp <= '9'){
    pos--;
    if(pos <= 0){
      break;
    }
    temp--;
  }
  temp++;
  return atoi(temp);
}


//---------------------------------------------------------------------------
//ĥҤΥå
//mp3 = 3
int CheckExt(char *name)
{
    int i,len;
    char temp[5];

    len = strlen(name);
    name += len;
    for(i=len-1;i>=0;i--){
      if(*name == '.'){
	name++;
	break;
      }
      name--;
    }
    for(i=0;i<5;i++){
      temp[i] = tolower(*name);
      name++;
    }

    if(strcmp(temp,"rmp") == 0)   return EXT_RMP;
    if(strcmp(temp,"mp3") == 0)   return EXT_MP3;
    if(strcmp(temp,"mp2") == 0)   return EXT_MP2;
    if(strcmp(temp,"mp1") == 0)   return EXT_MP1;
    if(strcmp(temp,"mpg") == 0)   return EXT_MPG;
    if(strcmp(temp,"wav") == 0)   return EXT_WAV;
    if(strcmp(temp,"m3u") == 0)   return EXT_M3U;

    return EXT_NONE;
}


/*-------------------------------------
//---------------------------------------------------------------------------
//ǥ쥯ȥ꤫ɤĴ٤
//ǥ쥯ȥäǸ\\ʤ֤
AnsiString CheckDir(AnsiString path)
{
    DIR *dir;
    int ext;

    if((dir = opendir(path.c_str())) != NULL){
        closedir(dir);
        ext = path.Length();
        if(path.SubString(ext,1) == "\\"){
            path.Delete(ext,1);
        }
    }else{
        path = "";
    }

    return path;
}
----------------------------------------*/

/*-------------------------------------------
//---------------------------------------------------------------------------
//ʲӥåȥޥå״ط
//---------------------------------------------------------------------------
void MakeTitleBarBmp(TMemoryStream *Des,int width,int height,
		     TColor left,TColor right)
{
    rgb leftColor,rightColor;
    int i,j;
    BitMapStruct Bmp;
    int intRed,intGreen,intBlue;


    leftColor.Blue = (left & 0xff0000) >> 16;//((left >> 16)&0xff);
    leftColor.Green = (left & 0xff00) >> 8;//((left >> 8)&0xff);
    leftColor.Red = (left&0xff);

    rightColor.Blue = (right & 0xff0000) >> 16;//((right >> 16)&0x00ff);
    rightColor.Green = (right & 0xff00) >> 8;//((right >> 8)&0x00ff);
    rightColor.Red = (right&0x00ff);


    Bmp.nColor = 0;

    Bmp.BitmapStream = new TMemoryStream();

    SetBmpHeader(&Bmp,width,height);


    //Υԡ
	if(Bmp.nColor){
	}else{
        for(i=0;i<height;i++){
            for(j=0;j<width;j++){//CeilFloor(256/width)){
                intRed = leftColor.Red - CeilFloor((double)((leftColor.Red-rightColor.Red)*j)/width);
                intGreen = leftColor.Green - CeilFloor((double)((leftColor.Green-rightColor.Green)*j)/width);
                intBlue = leftColor.Blue - CeilFloor((double)((leftColor.Blue-rightColor.Blue)*j)/width);

                if(intBlue > 255){
                    intBlue = 255;
                }else{
                    if(intBlue < 0){
                        intBlue = 0;
                    }
                }
                if(intRed > 255){
                    intRed = 255;
                }else{
                    if(intRed < 0){
                        intRed = 0;
                    }
                }
                if(intGreen > 255){
                    intGreen = 255;
                }else{
                    if(intGreen < 0){
                        intGreen = 0;
                    }
                }
                *Bmp.pImage++ = (BYTE)intBlue;
                *Bmp.pImage++ = (BYTE)intGreen;
        		*Bmp.pImage++ = (BYTE)intRed;
            }
            for(j=0;j<width%4;j++){
                *Bmp.pImage++ = 0;
            }    
        }
    }


	Bmp.BitmapStream->Seek(0,soFromBeginning);


//    Bmp.BitmapStream->SaveToFile("h:\\test1.bmp");

	Bmp.BitmapStream->Seek(0,soFromBeginning);
    memmove(Des->Memory,Bmp.BitmapStream->Memory,Bmp.nmem);


    
    delete Bmp.BitmapStream;

}
--------------------------------------*/

/*--------------------------------------
//ӥåȥޥåפΥإå
void SetBmpHeader(BitMapStruct *Bmp,int width,int height)
{
	Bmp->BitmapStream->Clear();
	Bmp->nmem = sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD)* Bmp->nColor + (width * height)*(Bmp->nColor?1:3)+height*(width%4);
	Bmp->BitmapStream->SetSize(Bmp->nmem);
	Bmp->pImage =(BYTE *) Bmp->BitmapStream->Memory;

 	Bmp->pBitmapFHeder = (BITMAPFILEHEADER *)Bmp->pImage;
 	Bmp->pBitmapFHeder->bfType = 'M' * 256 + 'B';
 	Bmp->pBitmapFHeder->bfSize = Bmp->nmem;
	Bmp->pBitmapFHeder->bfReserved1 = 0;
	Bmp->pBitmapFHeder->bfReserved2 = 0;
	Bmp->pBitmapFHeder->bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD)* Bmp->nColor;
	Bmp->pBitmapIHeder = (BITMAPINFOHEADER *)(Bmp->pImage +sizeof(BITMAPFILEHEADER));
	Bmp->pBitmapIHeder->biSize = sizeof(BITMAPINFOHEADER);//(Bitmap->Width * Bitmap->Height)*(nColor?1:3);
	Bmp->pBitmapIHeder->biWidth = width;
	Bmp->pBitmapIHeder->biHeight = height;
	Bmp->pBitmapIHeder->biPlanes = 1;
	Bmp->pBitmapIHeder->biBitCount = (BYTE)(Bmp->nColor?8:24);
	Bmp->pBitmapIHeder->biCompression = BI_RGB;
	Bmp->pBitmapIHeder->biSizeImage = 0;
	Bmp->pBitmapIHeder->biXPelsPerMeter = 0;
	Bmp->pBitmapIHeder->biYPelsPerMeter = 0;
	Bmp->pBitmapIHeder->biClrUsed = 0;//1 * Bmp->nColor;
	Bmp->pBitmapIHeder->biClrImportant = 0;

	Bmp->rgb = (RGBQUAD *)(Bmp->pImage +sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER));
	Bmp->pImage = Bmp->pImage + sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD)* Bmp->nColor;
    
}
-----------------------------------*/


/*----------------------------------
//ڤΤڤ夲
int CeilFloor(double interval)
{
    if(interval >= 1 || interval <= -1){
        return (int)interval;
    }else{
        if(interval < 0){
            return (int)floor(interval);
        }else{
            return (int)ceil(interval);
        }
    }
}
---------------------------------*/

/*--------------------------------------
//Τΰ礭ͤȤäƥ졼ˤ
TColor changeGray(TColor color)
{
    DWORD temp = (DWORD)color;
    BYTE basic[3] = {0,0,0};

    basic[0] = (BYTE)(temp & 0xff);
    basic[1] = (BYTE)((temp >> 8) & 0xff);
    basic[2] = (BYTE)((temp >> 16) & 0xff);

    if(basic[0] < basic[1]) basic[0] = basic[1];
    else                    basic[1] = basic[0];
    if(basic[2] < basic[1]) basic[2] = basic[1];
    else                    basic[1] = basic[2];
    if(basic[0] < basic[2]) basic[0] = basic[2];
    else                    basic[2] = basic[0];

    temp = basic[2];
    temp <<= 8;
    temp |= basic[1];
    temp <<= 8;
    temp |= basic[0];

    return (TColor)temp;
}

---==================================*/



//ʸ󤬤٤ƶ򤫤ɤΤ
BOOL strlen0(char *str)
{
  int len = strlen(str);
  int i;
  char *temp = str;
  
  for(i=0;i<len;i++){
    if(*temp != 0x20){
      return false;
    }
    temp++;
  }
  return true;
}

//ʸΥԡХȿʤʸξ
//
void strcopy(char *dest,char *src,int num)
{
    int i,flag=1;

    for(i=0;i<num;i++){
        if(flag){
            *dest++ = *src++;
        }else{
            *dest++ = ' ';
        }
        if(*src == '\0'){
            flag = 0;
        }
    }
}

//ʸӤ򤹤
int strcomp(char *left,char *right)
{
    int ret = 0;

    while(*left != 0 && *right != 0){
        if(*left < *right){
            ret = -1;
            break;
        }
        if(*left > *right){
            ret = 1;
            break;
        }
        left++;
        right++;
    }

    return ret;
}

int strncomp_ls(char *left,char *right,int num)
{
    int ret = 0,diff;

    for(int i=0;i<num;i++){
        if(*left == 0 && *right == 0){
            break;
        }

        diff = *left - *right;
        if(diff >= 32){
            diff -= 32;
        }
        if(diff <= -32){
            diff += 32;
        }

        if(diff < 0){
            ret = -1;
            break;
        }
        if(diff > 0){
            ret = 1;
            break;
        }
        left++;
        right++;
    }

    return ret;
}

//ʸˤ
void strlwr_A(char *dest)
{
  if(dest == NULL){
    return;
  }

  while(*dest != '\0'){
    *dest = (char)tolower(*dest);
    dest++;
  }

  return;
}

//Ԥ\0ˤ
void strtrim(char *dest)
{
  while(*dest != '\0'){
    if(*dest == '\n'){
      *dest = '\0';
      break;
    }
    dest++;
  }
}


//////////////////////////////////////////////////////////
// ʸѴؿ
//////////////////////////////////////////////////////////
void sjis2euc_single(unsigned char *c1,unsigned char *c2);
void euc2sjis_single(unsigned char *c1,unsigned char *c2);

//////////////////////////////////////////////////////////
// S-JISEUCѴ
void sjis2euc(unsigned char *dest,int num)
{
  if(dest == NULL){
    return;
  }

  for(int i=0;i<num;i++){
    if(*dest > 0x7F){
      sjis2euc_single(dest,dest+1);
      dest += 2;
      i++;   //ʸΤforΥ󥿤Ģ碌
    }else{
      dest++;
    }
  }

}
void sjis2euc_single( unsigned char *c1, unsigned char *c2)
{
  if( *c2 < 0x9f ){
    if( *c1 < 0xa0 ){
      *c1 -= 0x81;
      *c1 *= 2;
      *c1 += 0xa1;
    }else{
      *c1 -= 0xe0;
      *c1 *= 2;
      *c1 += 0xdf;
    }
    if( *c2 > 0x7f ){
      -- *c2;
    }
    *c2 += 0x61;
  }else{
    if( *c1 < 0xa0 ){
      *c1 -= 0x81;
      *c1 *= 2;
      *c1 += 0xa2;
    }else{
      *c1 -= 0xe0;
      *c1 *= 2;
      *c1 += 0xe0;
    }
    *c2 += 2;
  }
}


//////////////////////////////////////////////////////////
// EUCS-JISѴ
void euc2sjis(unsigned char *dest,int num)
{
  if(dest == NULL){
    return;
  }

  for(int i=0;i<num;i++){
    if(*dest > 0x7F){
      euc2sjis_single(dest,dest+1);
      dest += 2;
      i++;   //ʸΤforΥ󥿤Ģ碌
    }else{
      dest++;
    }
  }

}

void euc2sjis_single(unsigned char *c1,unsigned char *c2)
{
  /* 裲ХȤѴ */
  if( ( *c1 % 2 ) == 0 ){
    *c2 -= 0x02;
  }else{
    *c2 -= 0x61;
    if( *c2 > 0x7e ){
      ++ *c2;
    }
  }

  /* 裱ХȤѴ */ 
  if( *c1 < 0xdf ){
    ++ *c1;
    *c1 /= 2;
    *c1 += 0x30;
  }else{
    ++ *c1;
    *c1 /= 2;
    *c1 += 0x70;
  }

}
