/*=========================================================================
    BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

#ifndef _WIN_INC_
#define _WIN_INC_



#define MAX_PATH 256

//-----------------------------------
// 
typedef unsigned char BOOL;
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned int DWORD;
//typedef void* LPVOID;
//typedef char *AnsiString;

//-----------------------------------
// 
#define true 1
#define false 0


//-----------------------------------
// ä
typedef unsigned char LPARAM;

struct MSG{
  unsigned char message;
  unsigned char lParam;
  int wParam;
};


//-----------------------------------
// Τ
void Sleep(int minsec);


//-----------------------------------
// ӥåȥޥå״ط
typedef DWORD TColor;

typedef struct tagBITMAPFILEHEADER {
  WORD	bfType;		// "BM"
  DWORD	bfSize;		// ե륵
  WORD	bfReserved1;	// 0
  WORD	bfReserved2;	// 0
  DWORD	bfOffBits;	// DIBեƬԥǡΰƬޤǤΥեå
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER {
  DWORD	biSize;		// ι¤ΤΥ
  DWORD	biWidth;		// ʥԥñ̡
  DWORD	biHeight;		// ⤵ʥԥñ̡
  WORD	biPlanes;		// 1
  WORD	biBitCount;	// 1ԥ뤢Υ顼ӥåȤο
  DWORD	biCompression;	// BI_RGB, BI_RLE8, BI_RLE4Τ줫
  DWORD	biSizeImage;	// ᡼Хȿ
  DWORD	biXPelsPerMeter;	// 0ޤϿʿ
  DWORD	biYPelsPerMeter;	// 0ޤϿľ
  DWORD	biClrUsed;	// ̾0biBitCountʲΥ顼ǽ
  DWORD	biClrImportant;	// ̾0
} BITMAPINFOHEADER;

typedef struct tagRGBQUAD {
  BYTE	rgbBlue;		// Ĥε(0255)
  BYTE	rgbGreen;		// Фε(0255)
  BYTE	rgbRed;		// ֤ε(0255)
  BYTE	rgbReserved;	// ͽ͡0ˤ
} RGBQUAD;

typedef struct tagBITMAPINFO {
  BITMAPINFOHEADER	bmiHeader;
  RGBQUAD		bmiColors[1];
} BITMAPINFO;




//----------------------------------
// WAV
#define WAVE_FORMAT_PCM 0x0001
// Win32SDK(mmreg.h)
#define WAVE_FORMAT_ALAW 0x0006  /*  Microsoft Corporation  */
#define WAVE_FORMAT_MULAW 0x0007  /*  Microsoft Corporation  */


typedef struct { 
  WORD wFormatTag; 
  WORD nChannels; 
  DWORD nSamplesPerSec; 
  DWORD nAvgBytesPerSec; 
  WORD nBlockAlign; 
  WORD wBitsPerSample; 
  WORD cbSize; 
} WAVEFORMATEX; 

typedef WAVEFORMATEX *LPWAVEFORMATEX;


//---------------------------------------
// ط
void ZeroMemory(void *Destination,  // ֥å
		int Length       // ֥åΥ
		);

void CopyMemory(void *Destination,   // ԡ
		const void *Source,  // ԡ֥å
		int Length        // ֥åΥ
		);


//---------------------------------------
// ե
#define GENERIC_READ 1
#define GENERIC_WRITE 2
#define FILE_SHARE_READ 1
#define FILE_SHARE_WRITE 2
#define OPEN_EXISTING 4
#define FILE_ATTRIBUTE_NORMAL 8

#define FILE_BEGIN 0
#define FILE_CURRENT 1
#define FILE_END 2
#define INVALID_SET_FILE_POINTER (DWORD)NULL
#define INVALID_HANDLE_VALUE (DWORD)NULL

FILE *CreateFile(char *lpFileName,                        // ե̾
		 DWORD dwDesiredAccess,                     // ⡼
		 DWORD dwShareMode,                         // ͭ⡼
		 void *lpSecurityAttributes,
		 //LPSECURITY_ATTRIBUTES lpSecurityAttributes,// ƥһ
		 DWORD dwCreationDisposition,                // ˡ
		 DWORD dwFlagsAndAttributes,                 // ե°
		 void*  hTemplateFile       // ƥץ졼ȥեΥϥɥ
		 //HANDLE hTemplateFile       // ƥץ졼ȥեΥϥɥ
		 );


int GetFileSize(FILE *fp,void *y);

BOOL ReadFile(FILE *hFile,                /* եΥϥɥ */
	      void *lpBuffer,             // ǡХåե
	      DWORD nNumberOfBytesToRead,  // ɤ߼оݤΥХȿ
	      DWORD *lpNumberOfBytesRead, // ɤ߼äХȿ
	      //LPOVERLAPPED lpOverlapped // Сå׹¤ΤΥХåե
	      void *overlapped
	      );

BOOL WriteFile(FILE *hFile,                   // եΥϥɥ
	       void *lpBuffer,              // ǡХåե
	       DWORD nNumberOfBytesToWrite,   // 񤭹оݤΥХȿ
	       DWORD *lpNumberOfBytesWritten,// 񤭹Хȿ
	       //LPOVERLAPPED lpOverlapped,   // Сå׹¤ΤΥХåե
	       void *lpOverlapped
	       );

DWORD SetFilePointer(FILE *hFile,          // եϥɥ
		     long   lDistance,      // ̥եå
		     long *pDistanceHigh,  // ̥եåȤѿ
		     DWORD  dwMoveMethod    // ư
		     );


BOOL SetEndOfFile(FILE *hFile);

#endif
