GCC = g++
GCC2 = gcc
SRC = bieamp-con.cpp ctagedit.cpp
SRC-I = inputmp3.cpp id3tagv1.cpp id3tagv2.cpp lyrics.cpp riff.cpp
SRC-W = win.cpp other.cpp

SRC-I2 = $(SRC-I:%=input/%)
SRC-W2 = $(SRC-W:%=win/%)

OBJ = $(SRC:%.cpp=%.o)
OBJ-I = $(SRC-I2:%.cpp=%.o)
OBJ-W = $(SRC-W2:%.cpp=%.o)


bieamp: $(OBJ) $(OBJ-I) $(OBJ-W)
	$(GCC) -o $@ $(OBJ) $(OBJ-I) $(OBJ-W)

.cpp.o:
	$(GCC) -o $@ -c $< -DTAGEDIT_ONLY
bieamp-con.o: bieamp-con.cpp
ctagedit.o: ctagedit.cpp
inputmp3.o: inputmp3.cpp
id3tagv1.o: id3tagv1.cpp
id3tagv2.o: id3tagv2.cpp
lyrics.o: lyrics.cpp
riff.o: riff.cpp
other.o: other.cpp
win.o: win.cpp


clean:
	@rm -rf *.o *~ output/*.o output/*~ win/*.o win/*~ input/*.o input/*~

cleanall:
	@rm -rf bieamp *.o *~ output/*.o output/*~ win/*.o win/*~ input/*.o input/*~ input/mpegdecode/*.o input/mpegdecode/*~
