/*=========================================================================
    BieAmp with ID3Tag Editor
        Copyright (c) 2000-2002 Ayane Iori (Takayuki Orito)

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/
//---------------------------------------------------------------------------
#ifndef InputItemDBH
#define InputItemDBH

#include "inputplugin.h"

#include "../win/other.h"

//---------------------------------------------------------------------------
class TInputItemDB
{

private:
    InputItem *PlayListItems;       //ƥΥꥹ
    int CurrentTrack;               //ߤΥȥå(ܤϤޤ룰ܤϤʤ)
    int Items;                      //Ҥ餤Ƥ
    BOOL Operation;                 //ʤˤꥹȤԣңգš

public:
    TInputItemDB();
    virtual ~TInputItemDB();


    InputItem* AddItem(void);
    BOOL DelItem(int num);
    BOOL ClearItem(void);

    int GetCurrentTrack(void);
    int GetItemCount(void);
    InputItem *GetCurrentItem(void);
    InputItem *GetItem(int num);

    BOOL ExchangeItem(int dest,int src);

    BOOL SetItem(InputItem *item,int num);

    BOOL SetTrack(int num);
    BOOL SetNext(void);
    BOOL SetPrev(void);

    void ResetInputInfo(InputInfo *info);

    BOOL GetOperation();        //operation֤ͤ


    //
    void SortFileInfo(InputItem *items,int num,int mode,BOOL turn);
    void SortSecond(int sepa_mode,int sort_mode,BOOL turn);

//    int GetFileNumber(AnsiString path);

    BOOL CheckDuplicate(char *path);


};
//---------------------------------------------------------------------------
#endif
 
