/*=========================================================================
    InputMP3 Class
    for BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane
      
    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

#ifndef _INPUT_PLUGIN_INC_
#define _INPUT_PLUGIN_INC_


#define INFO_NAME_SIZE		128


struct InputInfo
{
  //ID3 ver1
  char szTrackName[INFO_NAME_SIZE+1];	//̾
  char szArtistName[INFO_NAME_SIZE+1];	//ƥ̾
  char szAlbumName[INFO_NAME_SIZE+1];
  char szYear[5];
  char szComment[INFO_NAME_SIZE+1];
  int szGenre;

  //¾
  int channels;
  int bitRate;		//ӥåȥ졼
  int samplingRate;	//ץ󥰥졼
  int totalSec;		//ջ
  
  int version;
  int layer;
  int mode;
  int modeExtension;
  //mode = 0 , modeExtension = 0 : stereo
  //mode = 1 , modeExtension = 0 : Join Stereo
  //mode = 1 , modeExtension = 2 : MS stereo
  //mode = 3 , modeExtension = 0 : Mono
  int copyright;
  int original;
  int emphasis;

};

struct InputItem{
  char path[MAX_PATH];
//    char filename[MAXFILE+MAXEXT];
  InputInfo info;
};


typedef int (/*CALLBACK*/ *INPUTPROC)(int id, int param, int userData);



#endif
