typedef void (*SBT_FUNCTION) (float *sample, void *pcm, int n);

void sbt_init();

void sbt_mono(float *sample, short *pcm, int n);
void sbt_dual(float *sample, short *pcm, int n);
void sbt_dual_mono(float *sample, short *pcm, int n);
void sbt_dual_left(float *sample, short *pcm, int n);
void sbt_dual_right(float *sample, short *pcm, int n);
void sbt16_mono(float *sample, short *pcm, int n);
void sbt16_dual(float *sample, short *pcm, int n);
void sbt16_dual_mono(float *sample, short *pcm, int n);
void sbt16_dual_left(float *sample, short *pcm, int n);
void sbt16_dual_right(float *sample, short *pcm, int n);
void sbt8_mono(float *sample, short *pcm, int n);
void sbt8_dual(float *sample, short *pcm, int n);
void sbt8_dual_mono(float *sample, short *pcm, int n);
void sbt8_dual_left(float *sample, short *pcm, int n);
void sbt8_dual_right(float *sample, short *pcm, int n);

/*--- 8 bit output ---*/
void sbtB_mono(float *sample, unsigned char *pcm, int n);
void sbtB_dual(float *sample, unsigned char *pcm, int n);
void sbtB_dual_mono(float *sample, unsigned char *pcm, int n);
void sbtB_dual_left(float *sample, unsigned char *pcm, int n);
void sbtB_dual_right(float *sample, unsigned char *pcm, int n);
void sbtB16_mono(float *sample, unsigned char *pcm, int n);
void sbtB16_dual(float *sample, unsigned char *pcm, int n);
void sbtB16_dual_mono(float *sample, unsigned char *pcm, int n);
void sbtB16_dual_left(float *sample, unsigned char *pcm, int n);
void sbtB16_dual_right(float *sample, unsigned char *pcm, int n);
void sbtB8_mono(float *sample, unsigned char *pcm, int n);
void sbtB8_dual(float *sample, unsigned char *pcm, int n);
void sbtB8_dual_mono(float *sample, unsigned char *pcm, int n);
void sbtB8_dual_left(float *sample, unsigned char *pcm, int n);
void sbtB8_dual_right(float *sample, unsigned char *pcm, int n);

void sbt_mono_L3(float *sample, signed short *pcm, int ch);
void sbt_dual_L3(float *sample, signed short *pcm, int ch);
void sbt16_mono_L3(float *sample, signed short *pcm, int ch);
void sbt16_dual_L3(float *sample, signed short *pcm, int ch);
void sbt8_mono_L3(float *sample, signed short *pcm, int ch);
void sbt8_dual_L3(float *sample, signed short *pcm, int ch);

void sbtB_mono_L3(float *sample, unsigned char *pcm, int ch);
void sbtB_dual_L3(float *sample, unsigned char *pcm, int ch);
void sbtB16_mono_L3(float *sample, unsigned char *pcm, int ch);
void sbtB16_dual_L3(float *sample, unsigned char *pcm, int ch);
void sbtB8_mono_L3(float *sample, unsigned char *pcm, int ch);
void sbtB8_dual_L3(float *sample, unsigned char *pcm, int ch);
