/*=========================================================================
    OutputAudio Class
    for BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

#ifndef _OUTPUT_AUDIO_H_
#define _OUTPUT_AUDIO_H_

#define NUM_WAVEHDR 4


typedef int HWAVEOUT;


struct OutputInfo
{
	int		channels;			//ͥ
	int		bitsPerSample;		//ӥåȿ/1ץ
	int		samplingRate;		//ץ󥰥졼
	int		outputSize;			//ɬפʥХåե
};


class OutputAudio
{
 private:
  HWAVEOUT m_hWaveOut;
  //	HANDLE		m_hSemaphore;
  int m_waveHdrIndex;
  //	WAVEHDR		m_waveHdrTable[NUM_WAVEHDR];

  int m_Esd;
  /*unsigned*/ char *m_pHost;
  int m_Sock;

  //ܥ塼ѹå
  BOOL m_vol_change;
  int m_vol_left;
  int m_vol_right;


 public:
  OutputAudio();
  ~OutputAudio();
	
  BOOL open(const char* pszName, OutputInfo* pInfo);
  BOOL close();
  
  BOOL write(const void* pData, int length);
  
  BOOL stop();
  BOOL pause();
  BOOL restart();
  BOOL setVolume(int left, int right);

  DWORD getVolume(int *left,int *right);
  DWORD getPosition();

  BOOL getVersion(char ver[]);

  static void  WaveProc(HWAVEOUT hWaveOut, WORD msg,DWORD instance,
			DWORD param1,DWORD param2);


};

#endif
