/*=========================================================================
    BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>

#include "win/win.h"
#include "win/other.h"
#include "define.h"
#include "common.h"

#include "prompt.h"


extern char *Genre[157];


//ޥɥ饤ѥ᡼طե饰ν
// define bieamp-con.cpp
extern struct control_flag con_flag;




//////////////////////////////////////////////////////////////
//
// ʲƥץΥޥɥ饤ǻѤؿ
//
//////////////////////////////////////////////////////////////

//---------------------------------------------------------
// ޥɤɤ߼Ȥν
void CommandPrompt(InputMP3 *im,TInputItemDB *idb)
{
  InputInfo iinfo;
  char buf[256];
  int c,param,param2;
  //ջɸ
  int second;
  int i;

  c = COM_RETURN;
  do{

    switch(c){
    case COM_HELP:
      //إ
      ShowHelp();
      break;

    case COM_SEEK:
      //
      second = im->getTime();
      
      printf("skip : %d+%d\n",second,param);
      if((second+param)>0){
	im->seek(second+param);
      }
      break;

    case COM_ID3TAG:
      im->getInputInfo(&iinfo);

      ShowTag(im,&iinfo);

      break;

    case COM_PAUSE:
      if(im->getState() == ST_PLAY){
	printf("Pause\n");
	im->pause();
      }else{
	printf("Not play music!\n");
      }
      break;

    case COM_PLAY:
      if(im->getState() == ST_PAUSE){
	printf("Play\n");
	im->restart();
      }else{
	printf("Not pause music!\n");
      }
      break;

    case COM_PREV:
      im->sendEvent(MSG_SEND_TO_OTHER_PROCESS,COM_PREV,0);
      im->stop();
      break;

    case COM_NEXT:
      im->stop();
      break;

    case COM_SET_VOLUME:
      printf("ʤǤޤm(_ _)m\n");
      /*
	if(param < 0){
	param = 0;
	}
	if(param > 100){
	param = 100;
	}
	if(im->setVolume(param,param) == true){
	printf("Set volume : %d\n",param);
	}else{
	printf("Don't set valume!\n");
	}
      */
      break;

    case COM_GET_VOLUME:
      im->getVolume(&param,&param2);
      printf("Volume : %d,%d\n",param,param2);
      break;

    case COM_TIME:
      second = im->getTime();
      im->getInputInfo(&iinfo);

      ShowTime(second,iinfo.totalSec);

      break;

    case COM_LIST:
      ShowPlayList(im,idb);
      break;

    case COM_SET_TRACK:
      im->sendEvent(MSG_SEND_TO_OTHER_PROCESS,COM_SET_TRACK,param);
      im->stop();
      break;

    case COM_EDIT_ID3TAG:
      EditTag(param,im,idb,false,NULL);
      break;

    case COM_EDIT_ID3TAG_LIST:
      EditTag(param,im,idb,true,NULL);
      break;

    case COM_RETURN:
      break;

    default:
      printf("unknown command\n");
    }
    printf("bieamp:>");
    if(fgets(buf,256,stdin) == (char*)NULL){
      break;
    }
    c = GetCommand(buf,&param);
  }while(c != COM_EXIT);

  im->sendEvent(MSG_SEND_TO_OTHER_PROCESS,COM_EXIT,0);

  if(im->getState() != ST_STOP){
    im->stop();
  }

}

//---------------------------------------------------------
// Ϥ줿ʸ󤫤饳ޥNOȥѥ᡼
int GetCommand(char *str,int *param)
{
  int com;
  char *src,*dest,buf[256];

  switch(*str){
  case 'h':
  case '?':
    com = COM_HELP;
    break;
  case 's':
    com = COM_PAUSE;
    break;
  case 'p':
    com = COM_PLAY;
    break;
  case 'f':
    com = COM_PREV;
    break;
  case 'n':
    com = COM_NEXT;
    break;
  case 'i':
    com = COM_ID3TAG;
    break;
  case 'R':
    com = COM_SEEK;
    break;
  case 'V':
    com = COM_SET_VOLUME;
    break;
  case 'v':
    com = COM_GET_VOLUME;
    break;
  case 't':
    com = COM_TIME;
    break;
  case 'l':
    com = COM_LIST;
    break;
  case 'T':
    com = COM_SET_TRACK;
    break;
  case 'E':
    com = COM_EDIT_ID3TAG;
    break;
  case 'L':
    com = COM_EDIT_ID3TAG_LIST;
    break;
  case '\n':
    com = COM_RETURN;
    break;
  case 'q':
    com = COM_EXIT;
    break;
  default:
    com = COM_NOT_FOUND;
    break;
  }

  if(param != NULL){
    src = str;
    dest = buf;

    src++;
    if(*src == ' '){
      src++;
      while(*src != '\n' && *src != ' '){
	*dest = *src;
	src++;
	dest++;
      }
      *dest = '\0';
      *param = atoi(buf);
    }else{
      *param = 0;
    }

  }

  return com;
}

//---------------------------------------------------------
//ääʬȻ֤ʬ򤹤
BOOL Sec2Time(int *hour,int *min,int *sec,int second)
{
  if(hour == NULL || min == NULL || sec == NULL){
    return false;
  }

  *min = (int)(second / 60);
  *sec = (int)(second % 60);
  *hour = (int)(*min / 60);
  *min = (int)(*min % 60);

  return true;
}


//----------------------------------------------------------
//֤ȥСɽ
void ShowTime(int second,int total)
{
  int min,sec;

  if(total == 0){
    total = 1;
  }

  //ߤλ
  min = (int)(second / 60);
  sec = (int)(second % 60);
  printf("%02d:%02d / ",min,sec);
  //ȡλ
  min = (int)(total / 60);
  sec = (int)(total % 60);
  printf("%02d:%02d ( %d / %d )\n",min,sec,second,total);
  //С
  sec = (int)(20 * second / total);
  printf(">");
  for(int i = 0;i<20;i++){
    if(i <= sec){
      printf("=");
    }else{
      printf("-");
    }
  }
  printf("<\n");


  return;
}


//----------------------------------------------------------
//إפɽ
void ShowHelp(void)
{
  //إ
  printf("<--- Get Command --->\n");
  printf("i : Show ID3Tag\n");
  printf("l : Show Play List\n");
  printf("s : Pause\n");
  printf("p : Release Pause\n");
  printf("f : Prev Track\n");
  printf("n : Next Track\n");
  printf("q : Stop and Exit\n");
  printf("t : Show Time\n");
  printf("v : Get volume\n");
  printf("<--- Set Command --->\n");
  printf("E [num] : Edit ID3Tag Info\n");
  printf("L [num] : Edit ID3Tag Info Roop\n");
  printf("R [second] : skip\n");
  printf("T [track no.] : Set Track\n");
  printf("V [volume] : Set volume(0-100) Sorry Un-mounting.\n");
  
  return;
}

//----------------------------------------------------------
//ID3Tagɽ
void ShowTag(InputMP3 *im,InputInfo *pInfo)
{
  InputInfo tinfo;

  if(pInfo == NULL){
    return;
  }

  //֤Υԡ
  tinfo = *pInfo;

  //ʸɤѴ(ɬפ)
  im->ConvertCharSet(&tinfo,false,con_flag.convert_char);

  if(tinfo.szGenre < 0 || tinfo.szGenre > 157){
    tinfo.szGenre = 0;
  }

  printf("<----------------------->\n");
  printf("TrackName = %s\n",tinfo.szTrackName);
  printf("Artist = %s \n",tinfo.szArtistName);
  printf("Album = %s\n",tinfo.szAlbumName);
  printf("Year = %s\n",tinfo.szYear);
  printf("Genre = %s\n",Genre[tinfo.szGenre]);
  printf("Comment = %s\n",tinfo.szComment);
  printf(" --- ---\n");
  if(tinfo.channels == 1){
    printf("channels = Υ\n");
  }else{
    printf("channels = ƥ쥪\n");
  }
  printf("bitRate = %dkBit/s\n",tinfo.bitRate);
  printf("samplingRate = %dHz\n",tinfo.samplingRate);
  /*
    printf("version = %d\n",pInfo->version);
    printf("layer = %d\n",pInfo->layer);
    printf("mode = %d\n",pInfo->mode);
  */
  printf("<----------------------->\n");
  
  return;
}

//----------------------------------------------------------
//ID3Tagɽñ
void ShowTagLite(InputMP3 *im,InputInfo *pInfo,int num)
{
  InputInfo tinfo;

  if(pInfo == NULL){
    return;
  }

  tinfo = *pInfo;

  //ʸɤѴ(ɬפ)
  im->ConvertCharSet(&tinfo,false,con_flag.convert_char);

  printf("%2d : %s : %s : %s\n",num
	 ,tinfo.szTrackName,tinfo.szArtistName,tinfo.szAlbumName);
    
  return;
}

//----------------------------------------------------------
//ץ쥤ꥹȤɽ
void ShowPlayList(InputMP3 *im,TInputItemDB *pItemDB)
{
  InputInfo iinfo;
  InputItem *pItem;
  int i;

  if(im == NULL || pItemDB == NULL){
    return;
  }

  for(i=0;i<pItemDB->GetItemCount();i++){
    pItem = pItemDB->GetItem(i+1);
    if(pItem != NULL){
      im->getFileInfo(pItem->path,&iinfo);
      ShowTagLite(im,&iinfo,i+1);
      //      printf("%2d : %s : %s\n",i,iinfo.szTrackName,iinfo.szArtistName);
    }
  }

}

//----------------------------------------------------------
//Խ
BOOL EditTag(int num,InputMP3 *im,TInputItemDB *pItemDB
	     ,BOOL roop,InputInfo *pInfoPrev)
{
  int itemcount = pItemDB->GetItemCount();
  InputInfo iinfo,tinfo;
  InputItem *pItem;
  char temp[130];
  int ext;


  if(num <= 0 || num > itemcount){
    fprintf(stderr,"Not found music No(%d).\n",num);
    return false;
  }

  pItem = pItemDB->GetItem(num);
  im->getFileInfo(pItem->path,&iinfo);

  //ʸɤѴ(ɬפ)
  im->ConvertCharSet(&iinfo,false,con_flag.convert_char);

  do{
    printf("          +---------+---------+---------+---------+--\n");
    printf("TrackName==%s\nTrackName>>",iinfo.szTrackName);
    fgets(temp,130,stdin);
    strtrim(temp);
    strncpy(tinfo.szTrackName,temp,INFO_NAME_SIZE);

    if(roop == true && pInfoPrev != NULL){
      //롼פǤФƤΤζʤξȤ
      strncpy(tinfo.szArtistName,pInfoPrev->szArtistName,INFO_NAME_SIZE);
      strncpy(tinfo.szAlbumName,pInfoPrev->szAlbumName,INFO_NAME_SIZE);
      strncpy(tinfo.szYear,pInfoPrev->szYear,5);
      tinfo.szGenre = pInfoPrev->szGenre;
    }else{
      //̾
      printf("Artist==%s\nArtist>>",iinfo.szArtistName);
      fgets(temp,130,stdin);
      strtrim(temp);
      strncpy(tinfo.szArtistName,temp,INFO_NAME_SIZE);
      
      printf("Album==%s\nAlbum>>",iinfo.szAlbumName);
      fgets(temp,130,stdin);
      strtrim(temp);
      strncpy(tinfo.szAlbumName,temp,INFO_NAME_SIZE);
      
      printf("Year==%s\nYear>>",iinfo.szYear);
      fgets(temp,130,stdin);
      strtrim(temp);
      temp[4] = '\0';
      strncpy(tinfo.szYear,temp,5);

      printf("Genre==%d(%s)\nGenre>>",iinfo.szGenre,Genre[iinfo.szGenre]);
      fgets(temp,14,stdin);
      temp[3] = '\0';
      tinfo.szGenre = atoi(temp);
      
    }

    printf("Comment==%s\nCommnet>>",iinfo.szComment);
    fgets(temp,130,stdin);
    strtrim(temp);
    strncpy(tinfo.szComment,temp,INFO_NAME_SIZE);
    
    printf("\n------- Information to change -------\n");
    printf("TrackName = %s\n",tinfo.szTrackName);
    printf("Artist = %s \n",tinfo.szArtistName);
    printf("Album = %s\n",tinfo.szAlbumName);
    printf("Year = %s\n",tinfo.szYear);
    printf("Genre = %s\n",Genre[tinfo.szGenre]);
    printf("Comment = %s\n",tinfo.szComment);
    printf("-- Changes OK? NO? OneMore? (y/n/o) > ");
    fgets(temp,20,stdin);
    
    if(temp[0] == 'y' || temp[0] == 'Y'){
      //ʸɤѴ(ɬפ)
      if(con_flag.convert_char == CC_SJIS2EUC){
	//ɹߤS-JISEUCʤΤ¸Ȥϵդ򤹤
	im->ConvertCharSet(&tinfo,true,con_flag.convert_char);
	fprintf(stderr,"Converted charactor code EUC to SJIS\n");
      }
      
      ext = CheckExt(pItem->path);
      if(ext == EXT_RMP){
	if(im->writeRIFFInfo(pItem->path,&tinfo) == false){
	  fprintf(stderr,"EditTag : Don't write RIFF Info\n");
	}
      }else{
	if(im->writeLYRICSInfo(pItem->path,&tinfo) == false){
	  fprintf(stderr,"EditTag : Don't write Lyrics Info\n");
	}
      }
      if(ext > EXT_NONE){
	if(im->writeID3v1Info(pItem->path,&tinfo) == false){
	  fprintf(stderr,"EditTag : Don't write ID3Tag Info\n");
	}
      }
    }
  }while(temp[0] == 'o' || temp[0] == 'O');
  
  if((num+1) <= itemcount && roop == true
     && (temp[0] == 'y' || temp[0] == 'Y')){
    printf("-- Is the following music edited?\n");
    printf("-- -> Yes? or  No? or Yes&SucceedInfo? (y/n/s) > ");
    fgets(temp,20,stdin);
    switch(temp[0]){
    case 's':
    case 'S':
      EditTag(num+1,im,pItemDB,roop,&tinfo);
      break;
    case 'y':
    case 'Y':
      EditTag(num+1,im,pItemDB,roop,NULL);
      break;
    default:
      break;
    }
  }
  
}


