/*=========================================================================
    BieAmp with ID3Tag Editor
        Copyright (c) 2000-2004 Iori Ayane

    MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
    Corp.  http://www.xingtech.com
=========================================================================*/

//fpos_tμǲΤ褦ʥ顼Ф礬Τǡ
//ξϡ#define FPOSפ򥳥ȥȤ뤳ȡ
// win/win.cpp: function  `int GetFileSize(FILE*, void*)':
// win/win.cpp:190: error: request for member `__pos' in `pos2', which is of
//    non-class type `fpos_t'
#define FPOS


#include <stdio.h>
#include <unistd.h>


#include "win.h"



/***************************************************


***************************************************/
void Sleep(int minsec)
{
  usleep(minsec*1000);
}




/***************************************************


***************************************************/

void ZeroMemory(void *Destination,  // ֥å
		int Length       // ֥åΥ
		)
{
  char *temp;

  if(Destination == NULL){
    return;
  }
  temp = (char *)Destination;
  for(int i=0;i<Length;i++){
    //    fprintf(stderr,"%d : %c\n",i,*temp);
    *temp = 0;
    temp++;
  }

  return;
}


void CopyMemory(void *Destination,   // ԡ
		const void *Source,  // ԡ֥å
		int Length        // ֥åΥ
		)
{
  char *dest,*src;

  if(Destination == NULL || Source == NULL){
    return;
  }

  dest = (char *)Destination;
  src = (char *)Source;
  for(int i=0;i<Length;i++){
    dest = src;
    dest++;
    src++;
  }
  
  return;
}





/********************************************************

եϴؿ Ƽ(ʲ)

********************************************************/

//------------------------------------
// ե
FILE *CreateFile(char *lpFileName,                        // ե̾
		 DWORD dwDesiredAccess,                     // ⡼
		 DWORD dwShareMode,                         // ͭ⡼
		 void *lpSecurityAttributes,
		 DWORD dwCreationDisposition,                // ˡ
		 DWORD dwFlagsAndAttributes,                 // ե°
		 void *hTemplateFile       // ƥץ졼ȥեΥϥɥ
		 )
{
  FILE *hFile;
  char mode[5] = {'r','+','b','\0','\0'};

  if(lpSecurityAttributes != NULL){
    printf("CreateFile : ERROR\n");
    return NULL;
  }
  if(hTemplateFile != NULL){
    printf("CreateFile : ERROR 1\n");
    return NULL;
  }

  if(lpFileName == NULL){
    printf("CreateFile : ERROR 2\n");
    return NULL;
  }

  if((dwDesiredAccess & GENERIC_READ) == GENERIC_READ){
    mode[0] = 'r';
    mode[1] = 'b';
    mode[2] = '\0';
  }
  if((dwDesiredAccess & GENERIC_WRITE) == GENERIC_WRITE){
    mode[0] = 'a';
    mode[1] = 'b';
    mode[2] = '\0';
  }
  if((dwDesiredAccess & (GENERIC_READ | GENERIC_WRITE)) ==
     (GENERIC_READ | GENERIC_WRITE)){
    mode[0] = 'r';
    mode[1] = '+';
    mode[2] = 'b';
    mode[3] = '\0';
  }

  if(lpSecurityAttributes != NULL){
    printf("CreateFile : ERROR 3 \n");
    return NULL;
  }

  if((dwShareMode & FILE_SHARE_READ) == 0){
    printf("CreateFile : ERROR 4 \n");
    return NULL;
  }
  //#define FILE_SHARE_WRITE 2

  if((dwCreationDisposition & OPEN_EXISTING) == 0){
    printf("CreateFile : ERROR 5\n");
    return NULL;
  }

  //#define FILE_ATTRIBUTE_NORMAL 8
  
  //  printf("file : %s , mode : %s\n",lpFileName,mode);
  hFile = fopen(lpFileName,mode);

  return hFile;
}


//------------------------------------
// ե륵μ
int GetFileSize(FILE *fp,void *y)
{
  fpos_t def,pos1,pos2;
  int size;

  if(fp == NULL){
    return 0;
  }
  //Ȥΰ
  if(fgetpos(fp,&def) != false){
    return 0;
  }
  //ǽ˰ư
  if(fseek(fp,0,SEEK_SET) != 0){
    return 0;
  }
  //եݥ󥿤ΰ֤(ǽ)
  if(fgetpos(fp,&pos1) != 0){
    fsetpos(fp,&def);
    return 0;
  }
  //եݥ󥿤Ǹ˰ư
  if(fseek(fp,0,SEEK_END) != 0){
    fsetpos(fp,&def);
    return 0;
  }
  //եݥ󥿤ΰ֤(Ǹ)
  if(fgetpos(fp,&pos2) != 0){
    fsetpos(fp,&def);
    return 0;
  }
  //եݥ󥿤ΰ֤Ȥˤɤ
  if(fsetpos(fp,&def) != 0){
    return 0;
  }

#ifdef FPOS
  return (pos2.__pos - pos1.__pos);
#else
  return (pos2 - pos1);
#endif
}


//------------------------------------
// ե뤫ǡɤߤ
BOOL ReadFile(FILE *hFile,void *lpBuffer,DWORD nNumberOfBytesToRead,
	      DWORD *lpNumberOfBytesRead,void *overlapped)
{
  fpos_t ptr,ptr2;

  //overlapped¤ΤˤбƤʤΤNULLʳ褿饨顼
  if(overlapped != NULL){
    return false;
  }
  if(hFile == NULL){
    return false;
  }
  if(lpBuffer == NULL){
    return false;
  }

  if(fgetpos(hFile,&ptr) != 0){
    return false;
  }
  if(fread(lpBuffer,nNumberOfBytesToRead,1,hFile) < 1){
    return false;
  }
  if(fgetpos(hFile,&ptr2) != 0){
    return false;
  }

#ifdef FPOS
  *lpNumberOfBytesRead = (DWORD)(ptr2.__pos - ptr.__pos);
#else
  *lpNumberOfBytesRead = (DWORD)(ptr2 - ptr);
#endif

  if(*lpNumberOfBytesRead < 0){
    return false;
  }

  return true;
}

//-----------------------------------
// ե˽񤭹
BOOL WriteFile(FILE *hFile,                   // եΥϥɥ
	       void *lpBuffer,              // ǡХåե
	       DWORD nNumberOfBytesToWrite,   // 񤭹оݤΥХȿ
	       DWORD *lpNumberOfBytesWritten,// 񤭹Хȿ
	       //LPOVERLAPPED lpOverlapped,   // Сå׹¤ΤΥХåե
	       void *overlapped
	       )
{
  fpos_t ptr,ptr2;

  //overlapped¤ΤˤбƤʤΤNULLʳ褿饨顼
  if(overlapped != NULL){
    return false;
  }
  if(hFile == NULL){
    return false;
  }

  if(fgetpos(hFile,&ptr) != 0){
    return false;
  }
  if(fwrite(lpBuffer,nNumberOfBytesToWrite,1,hFile) < 1){
    return false;
  }
  if(fgetpos(hFile,&ptr2) != 0){
    return false;
  }

#ifdef FPOS
  *lpNumberOfBytesWritten = (DWORD)(ptr2.__pos - ptr.__pos);
#else
  *lpNumberOfBytesWritten = (DWORD)(ptr2 - ptr);
#endif

  if(*lpNumberOfBytesWritten < 0){
    return false;
  }

  return true;
}

//-------------------------------------
// եݥ󥿤ư
DWORD SetFilePointer(FILE *hFile,long lDistance,long *pDistanceHigh,
		     DWORD dwMoveMethod)
{
  int origin = 0;
  fpos_t ptr;
  long test=0;

  if(hFile == NULL){
    return INVALID_SET_FILE_POINTER;
  }

  if(pDistanceHigh != NULL){
    fprintf(stderr,"pDistanceHigh is not NULL\n");
    return INVALID_SET_FILE_POINTER;
  }

  switch(dwMoveMethod){
  case FILE_BEGIN:
    origin = SEEK_SET;
    break;
  case FILE_CURRENT:
    origin = SEEK_CUR;
    break;
  case FILE_END:
    origin = SEEK_END;
    break;
  default:
    return INVALID_SET_FILE_POINTER;
  }

  fseek(hFile,lDistance,origin);

 //ϥݥ󥿤ΰ֤򤫤α!(^o^
  if(fgetpos(hFile,&ptr) != 0){
    test = ftell(hFile);
    //    printf("ptr : %ld , test : %ld\n",ptr,test);
    return INVALID_SET_FILE_POINTER;
  }
  /*  
  return (DWORD)ptr;
  */

  return 0;
}

//------------------------------------------
//ꤵ줿եǡեνEOFˤ
//ߤΥեݥ󥿤ΰ֤ذưޤ
BOOL SetEndOfFile(FILE *hFile)
{
  int offset;

  offset = ftell(hFile);

  if(offset == -1){
    return false;
  }

  if(ftruncate(fileno(hFile),offset) == -1){
    return false;
  }

  return true;
}

